"""
SVN supports substituting the HeadURL and the Revsion Number per file basis.
Using those two Strings we figure out a version String. 
If the HeadURL is a subdir of tag/ the name of this subdir is used else the
revision number. If none of both are available, trunk is used as the version
string.

To make this work use svn:keywords "Revision HeadURL" <file>!
"""
import re

def create( revString, headUrl ):
	tagRe = re.compile(r'tags/(.+)/', re.M)
	revRe = re.compile(r' (.+) \$$', re.M)
	
	revResults = revRe.findall( revString )
	tagResults = tagRe.findall( headUrl )
	
	version = 'trunk'
	
	if not tagResults == []:
		version = tagResults[0]
	elif not revResults == []:
		version = 'r'+revResults[0]

	return version

