package edu.teco.particles.pComponent.test;

import junit.framework.*;
import edu.teco.particles.pComponent.util.*;
import edu.teco.particles.pComponent.scope.*;
import edu.teco.particles.libParticle.*;

public class TestParser extends TestCase
{
  static
  {
    System.loadLibrary("particleJava");
  }

  public void testShortParser()
  {
    short posMax = 255;
    short posMin = 0;
    short negMin = -127;
    short negMax = 126;

    short data[] = { posMax, posMin, negMin, negMax };

    ParticleTuple pt;
    pt = new ParticleTuple("sda", data);

    TupleParser sp;
    sp = TupleParserFactory.create("Short");

    try
    {
      assertEquals(posMax, ((Short) sp.parse(pt)).shortValue());
      sp.setOffset(1);
      assertEquals(posMin, ((Short) sp.parse(pt)).shortValue());
      sp.setOffset(2);
      sp.setSigned(true);
      assertEquals(negMin, ((Short) sp.parse(pt)).shortValue());
      sp.setOffset(3);
      assertEquals(negMax, ((Short) sp.parse(pt)).shortValue());
    }
    catch (Exception e)
    {
      fail();
    }
  }

  public void testLongParser()
  {
    long sigMax = (short) Math.pow(2, 16);
    short sigMin = (short) Math.pow(2, -16);
    short data[] = { (byte) (sigMax >> 8), (byte) sigMax, (byte) (sigMin >> 8),
        (byte) sigMin };

    ParticleTuple pt;
    pt = new ParticleTuple("sda", data);

    TupleParser lp = TupleParserFactory.create("Long");

    try
    {
      assertEquals(sigMax, ((Long) lp.parse(pt)).longValue());
      lp.setSigned(true);
      lp.setOffset(2);
      assertEquals(sigMin, ((Long) lp.parse(pt)).longValue());
    }
    catch (Exception e)
    {
      fail();
    }
  }
}
