/*
 * Copyright (c) 2004
 * Telecooperation Office (TecO), Universitaet Karlsruhe (TH), Germany.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 * 3. Neither the name of the Universitaet Karlsruhe (TH) nor the names
 *    of its contributors may be used to endorse or promote products
 *    derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * @author Philipp Scholl <scholl@teco.edu>
 */
package edu.teco.particles.pComponent.test;

import junit.framework.*;
import edu.teco.particles.pComponent.util.*;
import edu.teco.particles.pComponent.scope.*;
import edu.teco.particles.libParticle.*;
import java.util.*;

public class TestTraceLtd extends TestCase
{
  static
  {
    System.loadLibrary("particleJava");
  }

  public void testTraceLtd()
  {
    Trace trace = new TraceLtd(1000);

    for (int i = 0; i < 1000; i++)
    {
      trace.addPoint(1, 4);
    }

    int j = 1;
    Iterator itr = trace.deltaIterator(1.0);
    while (itr.hasNext())
    {
      j++;
      itr.next();
    }
    assertEquals(1001, j);

    j = 1;
    itr = trace.deltaIterator(0.9);
    while (itr.hasNext())
    {
      j++;
      itr.next();
    }
    assertEquals(1001, j);

    j = 1;
    itr = trace.deltaIterator(1.9);
    while (itr.hasNext())
    {
      j++;
      itr.next();
    }
    assertEquals(501, j);

    j = 1;
    itr = trace.deltaIterator(2.0);
    while (itr.hasNext())
    {
      j++;
      itr.next();
    }
    assertEquals(501, j);
  }

}
